;;*****************************************************************************
;;*****************************************************************************
;;  FILENAME: BYPASS.inc
;;   Version: 2.1, Updated on 2003/08/20 at 17:13:06
;;  Generated by PSoC Designer ver 4.0 b865 : 27 August, 2003
;;
;;  DESCRIPTION: Assembler declarations for the Timer8 user module interface
;;               for the 22/24/27/28xxx PSoC family of devices
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress MicroSystems 2000-2003. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************

include "m8c.inc"


;--------------------------------------------------
; Constants for BYPASS API's.
;--------------------------------------------------

BYPASS_CONTROL_REG_START_BIT:              equ 0x01    ; Control register start bit
BYPASS_INT_REG:                            equ 0x0e1
BYPASS_INT_MASK:                           equ 0x80


;--------------------------------------------------
; Register Address Constants for BYPASS
;--------------------------------------------------

BYPASS_COUNTER_REG:                    equ 0x3c   ; DR0 Counter register
BYPASS_PERIOD_REG:                     equ 0x3d   ; DR1 Period register
BYPASS_COMPARE_REG:                    equ 0x3e   ; DR2 CompareValue register
BYPASS_CONTROL_REG:                    equ 0x3f   ; Control register
BYPASS_FUNC_REG:                       equ 0x3c   ; Function register
BYPASS_INPUT_REG:                      equ 0x3d   ; Input register
BYPASS_OUTPUT_REG:                     equ 0x3e   ; Output register


;--------------------------------------------------
; BYPASS Macro 'Functions'
;--------------------------------------------------

   macro BYPASS_Start_M
   or    reg[BYPASS_CONTROL_REG],  BYPASS_CONTROL_REG_START_BIT
   endm

   macro BYPASS_Stop_M
   and   reg[BYPASS_CONTROL_REG], ~BYPASS_CONTROL_REG_START_BIT
   endm

   macro BYPASS_EnableInt_M
   M8C_EnableIntMask BYPASS_INT_REG, BYPASS_INT_MASK
   endm

   macro BYPASS_DisableInt_M
   M8C_DisableIntMask BYPASS_INT_REG, BYPASS_INT_MASK
   endm


; end of file BYPASS.inc
