//*****************************************************************************
//*****************************************************************************
//  FILENAME:  InPGA.h  ( PGA )
//  Version: 3.0, Updated on 2003/08/27 at 14:03:13
//  Generated by PSoC Designer ver 4.0 b865 : 27 August, 2003
//
//  DESCRIPTION:  PGA User Module C Language interface file for the
//                22/24/27xxx PSoC family of devices.
//-----------------------------------------------------------------------------
//      Copyright (c) Cypress MicroSystems 2001-2003. All Rights Reserved.
//*****************************************************************************
//*****************************************************************************
#include <M8C.h>

//-------------------------------------------------
// Constants for InPGA API's.
//-------------------------------------------------
#define InPGA_OFF         0
#define InPGA_LOWPOWER    1
#define InPGA_MEDPOWER    2
#define InPGA_HIGHPOWER   3

#define InPGA_G48_0    0x0C
#define InPGA_G24_0    0x1C

#define InPGA_G16_0    0x08
#define InPGA_G8_00    0x18
#define InPGA_G5_33    0x28
#define InPGA_G4_00    0x38
#define InPGA_G3_20    0x48
#define InPGA_G2_67    0x58
#define InPGA_G2_27    0x68
#define InPGA_G2_00    0x78
#define InPGA_G1_78    0x88
#define InPGA_G1_60    0x98
#define InPGA_G1_46    0xA8
#define InPGA_G1_33    0xB8
#define InPGA_G1_23    0xC8
#define InPGA_G1_14    0xD8
#define InPGA_G1_06    0xE8
#define InPGA_G1_00    0xF8
#define InPGA_G0_93    0xE0
#define InPGA_G0_87    0xD0
#define InPGA_G0_81    0xC0
#define InPGA_G0_75    0xB0
#define InPGA_G0_68    0xA0
#define InPGA_G0_62    0x90
#define InPGA_G0_56    0x80
#define InPGA_G0_50    0x70
#define InPGA_G0_43    0x60
#define InPGA_G0_37    0x50
#define InPGA_G0_31    0x40
#define InPGA_G0_25    0x30
#define InPGA_G0_18    0x20
#define InPGA_G0_12    0x10
#define InPGA_G0_06    0x00



#pragma fastcall InPGA_Start
#pragma fastcall InPGA_SetPower
#pragma fastcall InPGA_SetGain
#pragma fastcall InPGA_Stop

//-------------------------------------------------
// Prototypes of the InPGA API.
//-------------------------------------------------
extern void InPGA_Start(BYTE bPowerSetting);
extern void InPGA_SetPower(BYTE bPowerSetting);
extern void InPGA_SetGain(BYTE bGainSetting);
extern void InPGA_Stop(void);

//-------------------------------------------------
// Register Addresses for InPGA
//-------------------------------------------------

#pragma ioport  InPGA_GAIN_CR0: 0x07d
BYTE            InPGA_GAIN_CR0;
#pragma ioport  InPGA_GAIN_CR1: 0x07e
BYTE            InPGA_GAIN_CR1;
#pragma ioport  InPGA_GAIN_CR2: 0x07f
BYTE            InPGA_GAIN_CR2;
#pragma ioport  InPGA_GAIN_CR3: 0x07c
BYTE            InPGA_GAIN_CR3;


// end of file InPGA.h
