;;*****************************************************************************
;;*****************************************************************************
;;  FILENAME:   LEVSHIFT.asm  
;;  Version: 2.1, Updated on 2003/08/26 at 16:07:58
;;  Generated by PSoC Designer ver 4.0 b865 : 27 August, 2003
;;
;;  DESCRIPTION: SCBLOCK User Module software implementation file for the
;;               22/24/25/26/27xxx PSoC family of devices.
;;
;;-----------------------------------------------------------------------------
;;  Copyright (c) Cypress MicroSystems 2000-2003. All Rights Reserved.
;;*****************************************************************************
;;*****************************************************************************


;; -----------------------------------------------------------------
;;                         Register Definitions
;; -----------------------------------------------------------------
;; BIT FIELD            Mask 
;; -----------------    ----- 
;; CR0.FCap              80
;; CR0.ClockPhase        40
;; CR0.ASign             20
;; CR0.ACap              1F
;; 
;; CR1.AMux              C0   SCB
;; CR1.ACMux             C0   SCA
;; CR1.BCap              1F
;;
;; CR2.AnalogBus         80
;; CR2.CmpBus            40
;; CR2.AutoZero          20
;; CR2.CCap              1F
;;
;; CR3.RefSelect         C0
;; CR3.FSW1              20
;; CR3.FSW0              10
;; CR3.BSW               08   SCB
;; CR3.BMux              04   SCB
;; CR3.BMux              0C   SCA
;; CR3.Power             03
;;

include "LEVSHIFT.inc"
include "m8c.inc"

;-----------------------------------------------
;  Global Symbols
;-----------------------------------------------
export  LEVSHIFT_Start
export _LEVSHIFT_Start
export  LEVSHIFT_SetPower
export _LEVSHIFT_SetPower
export  LEVSHIFT_Stop
export _LEVSHIFT_Stop

AREA UserModules (ROM, REL)

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: LEVSHIFT_Start
;  FUNCTION NAME: LEVSHIFT_SetPower
;
;  DESCRIPTION:
;    Applies power setting to the module's analog PSoc block.
;
;-----------------------------------------------------------------------------
;
;  ARGUMENTS:
;    A  contains the power setting 0-3
;
;  RETURNS:  NA
;
;  SIDE EFFECTS:
;    REGISTERS ARE VOLATILE:  THE A AND X REGISTERS MAY BE MODIFIED!
;
;  THEORY of OPERATION or PROCEDURE:
;
;-----------------------------------------------------------------------------
 LEVSHIFT_Start:
_LEVSHIFT_Start:
 LEVSHIFT_SetPower:
_LEVSHIFT_SetPower:
   and  A,03h
   push X
   mov  X,SP

   push A
   mov  A,reg[LEVSHIFT_cr3]
   and  A,~03h
   or   A,[X]
   mov  reg[LEVSHIFT_cr3],A
   pop  A
   pop  X
   ret
.ENDSECTION

.SECTION
;-----------------------------------------------------------------------------
;  FUNCTION NAME: LEVSHIFT_Stop
;
;  DESCRIPTION:
;    Removes power from the module's analog PSoC block
;-----------------------------------------------------------------------------
;
;  ARGUMENTS: None
;
;  RETURNS:  NA
;
;  SIDE EFFECTS:
;    REGISTERS ARE VOLATILE:  THE A AND X REGISTERS MAY BE MODIFIED!
;
;-----------------------------------------------------------------------------

 LEVSHIFT_Stop:
_LEVSHIFT_Stop:
   and  reg[LEVSHIFT_cr3],~03h
   ret
.ENDSECTION
 
; End of File LEVSHIFT.asm
