//*****************************************************************************
//*****************************************************************************
//  FILENAME: LPF.h
//   Version: 2.0, Updated on 2003/08/28 at 13:31:00
//  Generated by PSoC Designer ver 4.0 b865 : 27 August, 2003
//
//  DESCRIPTION: C declarations for the LPF2 User Module.
//-----------------------------------------------------------------------------
//      Copyright (c) Cypress MicroSystems YYYY. All Rights Reserved.
//*****************************************************************************
//*****************************************************************************

#include <m8c.h>

#pragma fastcall LPF_Start
#pragma fastcall LPF_SetPower
#pragma fastcall LPF_Stop
#pragma fastcall LPF_SetC1
#pragma fastcall LPF_SetC2
#pragma fastcall LPF_SetC3
#pragma fastcall LPF_SetC4
#pragma fastcall LPF_SetCA
#pragma fastcall LPF_SetCB


//-------------------------------------------------
// Prototypes of the LPF API.
//-------------------------------------------------

extern void LPF_Start(BYTE bPowerSetting);
extern void LPF_SetPower(BYTE bPowerSetting);
extern void LPF_Stop(void);
extern void LPF_SetC1(BYTE bCapValue);
extern void LPF_SetC2(BYTE bCapValue);
extern void LPF_SetC3(BYTE bCapValue);
extern void LPF_SetC4(BYTE bCapValue);
extern void LPF_SetCA(BYTE bCapValue);
extern void LPF_SetCB(BYTE bCapValue);


//-------------------------------------------------
// Defines for LPF API's.
//-------------------------------------------------

#define LPF_OFF                            (0x00)
#define LPF_LOWPOWER                       (0x01)
#define LPF_MEDPOWER                       (0x02)
#define LPF_HIGHPOWER                      (0x03)

#define LPF_FEEDBACK_16                    (0x00)
#define LPF_FEEDBACK_32                    (0x01)

//-------------------------------------------------
// Hardware Register Definitions
//-------------------------------------------------

#pragma ioport  LPF_FLIN_CR0:   0x09c                       //Analog SCA control register 0
BYTE            LPF_FLIN_CR0;
#pragma ioport  LPF_FLIN_CR1:   0x09d                       //Analog SCA control register 1
BYTE            LPF_FLIN_CR1;
#pragma ioport  LPF_FLIN_CR2:   0x09e                       //Analog SCA control register 2
BYTE            LPF_FLIN_CR2;
#pragma ioport  LPF_FLIN_CR3:   0x09f                       //Analog SCA control register 3
BYTE            LPF_FLIN_CR3;
#pragma ioport  LPF_FLOUT_CR0:  0x098                      //Analog SCB control register 0
BYTE            LPF_FLOUT_CR0;
#pragma ioport  LPF_FLOUT_CR1:  0x099                      //Analog SCB control register 1
BYTE            LPF_FLOUT_CR1;
#pragma ioport  LPF_FLOUT_CR2:  0x09a                      //Analog SCB control register 2
BYTE            LPF_FLOUT_CR2;
#pragma ioport  LPF_FLOUT_CR3:  0x09b                      //Analog SCB control register 3
BYTE            LPF_FLOUT_CR3;

//  LPF Cap naming convention per Gregorian and Temes, p293

#pragma ioport  LPF_FILT_C1_REG:    0x09c
BYTE            LPF_FILT_C1_REG;
#pragma ioport  LPF_FILT_C2_REG:    0x09d
BYTE            LPF_FILT_C2_REG;
#pragma ioport  LPF_FILT_C3_REG:    0x098
BYTE            LPF_FILT_C3_REG;
#pragma ioport  LPF_FILT_C4_REG:    0x09a
BYTE            LPF_FILT_C4_REG;
#pragma ioport  LPF_FILT_CA_REG:    0x09c
BYTE            LPF_FILT_CA_REG;
#pragma ioport  LPF_FILT_CB_REG:    0x098
BYTE            LPF_FILT_CB_REG;


// end of file LPF.h
