//*****************************************************************************
//*****************************************************************************
//  FILENAME: BYPASS.h
//   Version: 2.2, Updated on 2003/11/10 at 16:40:54
//  Generated by PSoC Designer ver 4.1 BETA b923 : 11 December, 2003
//
//  DESCRIPTION: Timer8 User Module C Language interface file
//               for the 22/24/27/28xxx PSoC family of devices
//-----------------------------------------------------------------------------
//  Copyright (c) Cypress MicroSystems 2000-2003. All Rights Reserved.
//*****************************************************************************
//*****************************************************************************

#include <m8c.h>

#pragma fastcall BYPASS_EnableInt
#pragma fastcall BYPASS_DisableInt
#pragma fastcall BYPASS_Start
#pragma fastcall BYPASS_Stop
#pragma fastcall BYPASS_bReadTimer                // Read  DR0
#pragma fastcall BYPASS_bReadTimerSaveCV          // Read  DR0
#pragma fastcall BYPASS_WritePeriod               // Write DR1
#pragma fastcall BYPASS_bReadCompareValue         // Read  DR2
#pragma fastcall BYPASS_WriteCompareValue         // Write DR2

// The following symbols are deprecated.
// They may be omitted in future releases
//
#pragma fastcall bBYPASS_ReadCounter              // Read  DR0 "Obsolete"
#pragma fastcall bBYPASS_CaptureCounter           // Read  DR0 "Obsolete"
#pragma fastcall bBYPASS_ReadTimer                // Read  DR0 (Deprecated)
#pragma fastcall bBYPASS_ReadTimerSaveCV          // Read  DR0 (Deprecated)
#pragma fastcall bBYPASS_ReadCompareValue         // Read  DR2 (Deprecated)


//-------------------------------------------------
// Prototypes of the BYPASS API.
//-------------------------------------------------

extern void BYPASS_EnableInt(void);
extern void BYPASS_DisableInt(void);
extern void BYPASS_Start(void);
extern void BYPASS_Stop(void);
extern BYTE BYPASS_bReadTimer(void);
extern BYTE BYPASS_bReadTimerSaveCV(void);
extern void BYPASS_WritePeriod(BYTE bPeriod);
extern BYTE BYPASS_bReadCompareValue(void);
extern void BYPASS_WriteCompareValue(BYTE bCompareValue);

// The following functions are deprecated.
// They may be omitted in future releases
//
extern BYTE bBYPASS_ReadCompareValue(void);       // Deprecated
extern BYTE bBYPASS_ReadTimerSaveCV(void);        // Deprecated
extern BYTE bBYPASS_ReadCounter(void);            // Obsolete
extern BYTE bBYPASS_ReadTimer(void);              // Deprecated
extern BYTE bBYPASS_CaptureCounter(void);         // Obsolete


//--------------------------------------------------
// Constants for BYPASS API's.
//--------------------------------------------------

#define BYPASS_CONTROL_REG_START_BIT           ( 0x01 )
#define BYPASS_INT_REG_ADDR                    ( 0x0e1 )
#define BYPASS_INT_MASK                        ( 0x80 )


//--------------------------------------------------
// Constants for BYPASS user defined values
//--------------------------------------------------

#define BYPASS_PERIOD                          ( 0x00 )
#define BYPASS_COMPARE_VALUE                   ( 0x00 )


//-------------------------------------------------
// Register Addresses for BYPASS
//-------------------------------------------------

#pragma ioport  BYPASS_COUNTER_REG: 0x03c                  //DR0 Count register
BYTE            BYPASS_COUNTER_REG;
#pragma ioport  BYPASS_PERIOD_REG:  0x03d                  //DR1 Period register
BYTE            BYPASS_PERIOD_REG;
#pragma ioport  BYPASS_COMPARE_REG: 0x03e                  //DR2 Compare register
BYTE            BYPASS_COMPARE_REG;
#pragma ioport  BYPASS_CONTROL_REG: 0x03f                  //Control register
BYTE            BYPASS_CONTROL_REG;
#pragma ioport  BYPASS_FUNC_REG:    0x13c                  //Function register
BYTE            BYPASS_FUNC_REG;
#pragma ioport  BYPASS_INPUT_REG:   0x13d                  //Input register
BYTE            BYPASS_INPUT_REG;
#pragma ioport  BYPASS_OUTPUT_REG:  0x13e                  //Output register
BYTE            BYPASS_OUTPUT_REG;
#pragma ioport  BYPASS_INT_REG:       0x0e1                //Interrupt Mask Register
BYTE            BYPASS_INT_REG;


//-------------------------------------------------
// BYPASS Macro 'Functions'
//-------------------------------------------------

#define BYPASS_Start_M \
   ( BYPASS_CONTROL_REG |=  BYPASS_CONTROL_REG_START_BIT )

#define BYPASS_Stop_M  \
   ( BYPASS_CONTROL_REG &= ~BYPASS_CONTROL_REG_START_BIT )

#define BYPASS_EnableInt_M   \
   M8C_EnableIntMask(  BYPASS_INT_REG, BYPASS_INT_MASK )

#define BYPASS_DisableInt_M  \
   M8C_DisableIntMask( BYPASS_INT_REG, BYPASS_INT_MASK )


// end of file BYPASS.h
