//*****************************************************************************
//*****************************************************************************
//  FILENAME:  CMPPR.h
//  Version: 3.1, Updated on 2003/11/18 at 14:59:22
//  Generated by PSoC Designer ver 4.1 BETA b923 : 11 December, 2003
//
//  DESCRIPTION:  CMPPRG User Module C Language interface file for the
//                22/24/27xxx PSoC family of devices.
//-----------------------------------------------------------------------------
//      Copyright (c) Cypress MicroSystems 2000-2003. All Rights Reserved.
//*****************************************************************************
//*****************************************************************************

#include <M8C.h>

//-------------------------------------------------
// Defines for CMPPR API's.
//-------------------------------------------------
#define CMPPR_OFF         0
#define CMPPR_LOWPOWER    1
#define CMPPR_MEDPOWER    2
#define CMPPR_HIGHPOWER   3

#define CMPPR_REF1_000   0xf0
#define CMPPR_REF0_937   0xe0
#define CMPPR_REF0_875   0xd0
#define CMPPR_REF0_812   0xc0
#define CMPPR_REF0_750   0xb0
#define CMPPR_REF0_688   0xa0
#define CMPPR_REF0_625   0x90
#define CMPPR_REF0_562   0x80
#define CMPPR_REF0_500   0x70
#define CMPPR_REF0_437   0x60
#define CMPPR_REF0_375   0x50
#define CMPPR_REF0_312   0x40
#define CMPPR_REF0_250   0x30
#define CMPPR_REF0_188   0x20
#define CMPPR_REF0_125   0x10
#define CMPPR_REF0_062   0x00
#define CMPPR_REF0_042   0x14
#define CMPPR_REF0_021   0x04


#pragma fastcall CMPPR_Start
#pragma fastcall CMPPR_SetPower
#pragma fastcall CMPPR_SetRef
#pragma fastcall CMPPR_Stop

//-------------------------------------------------
// Prototypes of the CMPPR API.
//-------------------------------------------------
extern void CMPPR_Start(BYTE bPowerSetting);
extern void CMPPR_SetPower(BYTE bPowerSetting);
extern void CMPPR_SetRef(BYTE bRefValue);
extern void CMPPR_Stop(void);

//-------------------------------------------------
// Hardware Register Definitions
//-------------------------------------------------
#pragma ioport  CMPPR_COMP_CR0: 0x071
BYTE            CMPPR_COMP_CR0;
#pragma ioport  CMPPR_COMP_CR1: 0x072
BYTE            CMPPR_COMP_CR1;
#pragma ioport  CMPPR_COMP_CR2: 0x073
BYTE            CMPPR_COMP_CR2;
#pragma ioport  CMPPR_COMP_CR3: 0x070
BYTE            CMPPR_COMP_CR3;

// end of file CMPPR.h
